jQuery(function($){
    var checkout_form = $('form.checkout');

    /**
     * When the checkout place order button is clicked,
     * first validate the order and save it to make sure it is okay and
     * send back a "fake" error before submitting a payment to Truevo.
     */
    checkout_form.on('checkout_place_order', function () {
        if ($('#truevo_inline_flow_validation_check').length == 0) {
            checkout_form.append('<input type="hidden" id="truevo_inline_flow_validation_check" name="validate_order_inline_checkout" value="1">');
        }
        return true;
    });

    /**
     * If checkout is updated and the widget needs to reload,
     * notify Truevo that it is not an abandoned session.
     */
    $(document.body).on('update_checkout', function () {
        TruevoCheckout.onAbandonedSession(TruevoCheckout.session_id)
    });

    /**
     * Check for the "fake" error to confirm order validation
     * and send through an inlinePay request to Truevo.
     */
    $(document.body).on('checkout_error', function () {
        var order_details = {};
        let error_count = $('.woocommerce-error li').length;

        // Remove fake error
        $('.woocommerce-info').each(function(){
            if ($(this).data('truevo-inline-flow-validated')) {
                order_details = $(this);
                return false; // Break out of foreach loop
            }
        });

        // Validation Passed
        if (error_count === 0 && !$.isEmptyObject(order_details)) {
            blockCheckoutForm();

            //prevent auto scroll up due to a notice
            jQuery( 'html, body' ).stop();

            // Update Truevo form action
            $("#truevo-transaction-complete-form").attr('action', order_details.data('truevo-submit-url'));

            // Update the configuration in the inline pay
            TruevoCheckout.inlinePay({
                transaction: order_details.data('truevo-order-transaction'),
                customer: order_details.data('truevo-order-customer')
            });
        }
          });
        
    /**
     * Add an overlay to the form to prevent it being edited again
     */
    function blockCheckoutForm() {
        $('#customer_details').block({
            message: null,
            overlayCSS: {
                background: "#fff",
                opacity: .6
            }
        });
        const payButton = document.getElementById('place_order');
        payButton.setAttribute('disabled', true);
        $("#place_order").css("cursor", "not-allowed");
    }
});